=== debian/changelog ===
libinstpatch (1.1.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for build breakage in reverse dependencies.
    (Closes: #1117839)

 -- Adrian Bunk <bunk@debian.org>  Thu, 16 Oct 2025 15:51:52 +0300

libinstpatch (1.1.7-1) unstable; urgency=medium

  * New upstream version 1.1.7
    + Fix build with GCC-15 (Closes: #1097199)
    + Fix build with CMake 4 (Closes: #1113158)
  * Change my email address
  * Remove unnecessary constraints
  * Bump Standards-Version to 4.7.2

 -- Dennis Braun <snd@debian.org>  Sun, 28 Sep 2025 19:55:52 +0200
