=== debian/control ===
Source: libinstpatch
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <snd@debian.org>,
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gettext,
 intltool,
 libglib2.0-dev,
 libsndfile1-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/multimedia-team/libinstpatch.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libinstpatch
Homepage: https://github.com/swami/libinstpatch

Package: libinstpatch-1.0-2
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIDI instrument editing library
 libInstPatch stands for lib-Instrument-Patch and is a library for
 processing digital sample based MIDI instrument "patch" files.
 The types of files libInstPatch supports are used for creating
 instrument sounds for wavetable synthesis. This library provides
 an object framework (based on GObject) to load patch files into,
 which can then be edited, converted, compressed and saved.
 .
 More information can be found on the Project Swami website
 http://swami.sourceforge.net.
 .
 This package contains the shared library.

Package: libinstpatch-dev
Section: libdevel
Architecture: any
Depends:
 libglib2.0-dev,
 libinstpatch-1.0-2 (= ${binary:Version}),
 libsndfile1-dev,
 pkgconf,
 ${misc:Depends}
Multi-Arch: same
Description: MIDI instrument editing library development files
 libInstPatch stands for lib-Instrument-Patch and is a library for
 processing digital sample based MIDI instrument "patch" files.
 The types of files libInstPatch supports are used for creating
 instrument sounds for wavetable synthesis. This library provides
 an object framework (based on GObject) to load patch files into,
 which can then be edited, converted, compressed and saved.
 .
 More information can be found on the Project Swami website
 http://swami.sourceforge.net.
 .
 This package contains the headers and static library.
