=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install -plibinstpatch-dev usr/include
	dh_install -plibinstpatch-dev usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
	dh_install -plibinstpatch-dev usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*
	dh_install -plibinstpatch-1.0-2 usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	dh_install --remaining-packages
